#pragma once
#include <iostream>
#include <string>
#include "Structures.h"
#include <vector>
#include <set>
#include <unordered_set>

class MeshLoader
{
protected:
    std::vector<Node> Nodes;
    std::vector<FiniteElement> FiniteElements;
    std::vector<BoundaryFiniteElement> BoundaryFiniteElements;
public:
    virtual void LoadMesh(std::string path) = 0;
    std::vector<Node>& getNodes();
    std::vector<FiniteElement>& getFiniteElements();
    std::vector<BoundaryFiniteElement>& getBoundaryFiniteElements();
    std::vector<FiniteElement> findElem(int id_1, int id_2);
    std::vector<FiniteElement> findElem(int id_1, int id_2, int id_3);
    std::vector<Node> getNodesByBoundaryFiniteElementId(int id);
    std::vector<FiniteElement> getElementsByBoundaryId(int id);
    std::vector<BoundaryFiniteElement> getsBoundaryFiniteElementByBoundaryId(int id);
    std::vector<std::set<int>> getNodeNeighbours();
    void insertCenterNode();
};
std::ostream& operator<<(std::ostream& stream, MeshLoader& mesh);